package kioskapp.util;

package ..deTemp.1748500670545;

import cfca.paperless.client.servlet.CompoundSealAutoPdf;
import cfca.paperless.client.servlet.CompoundSealAutoPdfWZW;
import com.gwi.util.SealImgUtil;
import java.io.File;
import java.io.UnsupportedEncodingException;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import kiosk.local.Local;
import kiosk.util.Base64;
import kiosk.util.GwiXMLWorkerHelper;
import kiosk.util.KDate;
import kiosk.util.KSysUtil;
import kiosk.util.kits.AppParamsHelper;
import kiosk.util.kits.CodeTableHelper;
import kiosk.util.kits.ErrorsHelper;
import kioskapp.bean.IDCardinfo;
import kioskapp.util.FunHelper;
import kioskapp.util.HtmReportHelper;
import kioskapp.util.TermConfigHelper;
import kioskapp.util.TradePackXml;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import rtl.kits.connect.ConnectParameter;
import rtl.kits.connect.socket.SocketConnectorEx;
import rtl.kits.connect.socket.SocketParameter;
import rtl.log.Log;
import rtl.model.ActionInternalModel;

public class VoucherHelper {
  public static final String CARDNO_OLD = "cardno_old";
  
  public static final String FILE_SEP = File.separator;
  
  public static boolean getPreProcessVoucherFile(ActionInternalModel iModel, Local local, Log log) {
    log.trace("调用   getPreProcessVoucherFile getVoucherFile()");
    boolean ret = false;
    try {
      String rptFile = (String)iModel.get("voucherRptFile");
      log.debug("getVoucherFile() rptFile==  " + rptFile);
      String printFile = (String)iModel.get("voucherFileName");
      log.debug("getVoucherFile() printFileName==  " + printFile);
      String voucherFilesPath = (String)iModel.getSession()
        .getAttribute("voucherFilesPath");
      voucherFilesPath = String.valueOf(voucherFilesPath) + "/";
      String filePathAndName = String.valueOf(KSysUtil.getWebRoot()) + voucherFilesPath + 
        printFile;
      log.info("getWebRoot:" + KSysUtil.getWebRoot());
      log.debug("file.separator:" + FILE_SEP);
      if (!filePathAndName.startsWith("/") && "/".equals(FILE_SEP))
        filePathAndName = "/" + filePathAndName; 
      if (filePathAndName.startsWith("/") && !"/".equals(FILE_SEP))
        filePathAndName = filePathAndName.substring(1); 
      String printFilePath_fk = String.valueOf(FunHelper.getFullCtxPath(iModel)) + "/" + 
        voucherFilesPath + printFile;
      log.debug("getPreProcessVoucherFile() printFilePath_fk==  " + 
          printFilePath_fk);
      log.debug("getPreProcessVoucherFile() filePathAndName==  " + 
          filePathAndName);
      ret = HtmReportHelper.replaceExpress(iModel.getRequest(), rptFile, 
          filePathAndName).booleanValue();
      log.debug("getPreProcessVoucherFile() createPrintFile==" + ret);
      iModel.getSession().setAttribute("printFilePath_fk", 
          printFilePath_fk);
    } catch (Exception e) {
      log.error("getPreProcessVoucherFile()  获取凭证打印数据出错");
      e.printStackTrace();
    } 
    return ret;
  }
  
  public static boolean getVoucherFile(ActionInternalModel iModel, Local local, Log log) {
    log.trace("调用   VoucherHelper getVoucherFile()");
    boolean ret = false;
    try {
      String businessType = (String)iModel.getSession().getAttribute(
          "businessType");
      TermConfigHelper termInfo = new TermConfigHelper(iModel);
      String rptFile = (String)iModel.get("voucherRptFile");
      log.debug("getVoucherFile() rptFile==  " + rptFile);
      String printFile = (String)iModel.get("voucherFileName");
      String devId = termInfo.getDevId();
      String lp_no = termInfo.getBrchno();
      String ygwxhyz = CodeTableHelper.getCodeName("ygwzhyz", lp_no);
      String imgPath = CodeTableHelper.getCodeName("ygxzimgpath", lp_no);
      iModel.getSession().setAttribute("imgPath", imgPath);
      log.trace("网点行章===========" + ygwxhyz);
      String filePath = KSysUtil.getWebRoot();
      log.info("getWebRoot:" + KSysUtil.getWebRoot());
      log.debug("file.separator:" + FILE_SEP);
      if (!filePath.startsWith("/") && "/".equals(FILE_SEP))
        filePath = "/" + filePath; 
      if (filePath.startsWith("/") && !"/".equals(FILE_SEP))
        filePath = filePath.substring(1); 
      String codeYz = "";
      String htmlFileN = "";
      htmlFileN = (String)iModel.getSession().getAttribute("htmlFileN");
      log.debug("getVoucherFile() htmlFileN==  " + htmlFileN);
      if (htmlFileN == null || "".equals(htmlFileN))
        iModel.getSession().setAttribute("htmlFileN", printFile); 
      if (htmlFileN != null && !"".equals(htmlFileN) && 
        htmlFileN.equals(printFile)) {
        iModel.getSession().setAttribute("htmlFileN", null);
        if ("H1".equals(businessType) || "T1".equals(businessType) || 
          "k1".equals(businessType) || 
          "B1".equals(businessType) || 
          "32".equals(businessType)) {
          codeYz = getYZCode(iModel, local, log, termInfo);
          String elec_stamper = imgPath;
          String elec_stamper_orginPath = String.valueOf(filePath) + 
            "app/local/chinese/image/" + elec_stamper;
          String elec_stamper_path = String.valueOf(filePath) + "app/temp/" + devId + 
            "/voucher/" + elec_stamper;
          log.info("elec_stamper_orginPath===" + 
              elec_stamper_orginPath);
          try {
            log.info("elec_stamper_path===" + elec_stamper_path);
            SealImgUtil.addOrgNameAndHashcode(
                elec_stamper_orginPath, "", 
                "", codeYz, 
                elec_stamper_path);
            log.info("elec_stamper_path===" + elec_stamper_path);
          } catch (Throwable t) {
            log.info("addOrgNameAndHashcode Exception" + t);
            t.printStackTrace();
          } 
          String vertifycodebase64 = 
            Base64.toBit64(elec_stamper_path);
          iModel.getSession().setAttribute("vertifycodebase64", 
              vertifycodebase64);
        } 
      } 
      log.info("印章编码****codeYz===" + codeYz);
      log.debug("getVoucherFile() printFileName==  " + printFile);
      IDCardinfo idCardInfo = (IDCardinfo)iModel.getSession()
        .getAttribute("IDCardinfo");
      String mobile = (String)iModel.getSession().getAttribute("Mobile");
      String filePathAndName = String.valueOf(filePath) + "app/temp/" + devId + 
        "/voucher/" + printFile;
      log.debug("getVoucherFile() filePathAndName==  " + filePathAndName);
      String printFilePath_fk = String.valueOf(filePath) + "/app/temp/" + devId + 
        "/voucher/" + printFile;
      log.debug("getVoucherFile() printFilePath_fk==  " + 
          printFilePath_fk);
      log.debug("getVoucherFile() filePathAndName==  " + filePathAndName);
      ret = HtmReportHelper.replaceExpress(iModel.getRequest(), rptFile, 
          filePathAndName).booleanValue();
      log.debug("getVoucherFile() createPrintFile==" + ret);
      log.debug("htmlFileN==" + htmlFileN);
      if (htmlFileN != null) {
        boolean httpFlag = false;
        String fontPath = String.valueOf(filePath) + 
          "/app/local/chinese/report/newcard/fonts/";
        String iamgepath = String.valueOf(filePath) + "/app/temp/" + devId + 
          "/voucher/";
        log.debug("getVoucherFile() iamgepath==" + iamgepath);
        String pdfFileName = String.valueOf(iamgepath) + 
          printFile.substring(0, printFile.indexOf(".")) + 
          ".pdf";
        log.debug("getVoucherFile() pdfFileName==" + pdfFileName);
        log.debug("getVoucherFile() fontPath==" + fontPath);
        GwiXMLWorkerHelper gwh = 
          GwiXMLWorkerHelper.getInstance(fontPath);
        log.debug("businessType==" + businessType);
        if ("WPL".equals(businessType) || "WL".equals(businessType) || 
          "t1".equals(businessType) || 
          "c3".equals(businessType) || 
          "f3".equals(businessType) || 
          "f4".equals(businessType) || 
          "t7".equals(businessType) || 
          "z1".equals(businessType) || 
          "z2".equals(businessType) || 
          "k1".equals(businessType) || 
          "f5".equals(businessType) || 
          "B1".equals(businessType) || 
          "14".equals(businessType) || 
          "15".equals(businessType) || 
          "16".equals(businessType) || 
          "17".equals(businessType) || 
          "32".equals(businessType) || 
          "X1".equals(businessType) || 
          "d1".equals(businessType)) {
          gwh.parseXHtmlEx(pdfFileName, printFilePath_fk, iamgepath, 
              httpFlag);
        } else {
          gwh.parseXHtml(pdfFileName, printFilePath_fk, iamgepath, 
              httpFlag);
        } 
        log.debug("下面时把生成的pdf发送无纸化系统，合成有证书的pdf文件");
        CompoundSealAutoPdf cfcapdf = new CompoundSealAutoPdf();
        if ("fk_print_voucher.html".equals(htmlFileN)) {
          CompoundSealAutoPdf.getPdfFileofCFCA(iModel, local, log, 
              idCardInfo, mobile, printFile, ygwxhyz);
        } else if ("qy_print_voucher.html".equals(htmlFileN)) {
          CompoundSealAutoPdf.getPdfFileofCFCA(iModel, local, log, 
              idCardInfo, mobile, printFile, ygwxhyz);
        } else if ("tu_print_voucher.html".equals(htmlFileN)) {
          CompoundSealAutoPdf.getPdfFileofCFCA(iModel, local, log, 
              idCardInfo, mobile, printFile, ygwxhyz);
        } else if ("td_print_voucher.html".equals(htmlFileN)) {
          CompoundSealAutoPdf.getPdfFileofCFCA(iModel, local, log, 
              idCardInfo, mobile, printFile, ygwxhyz);
        } else {
          log.debug("CompoundSealAutoPdfWZW");
          CompoundSealAutoPdfWZW.getPdfFileofCFCA(iModel, local, log, 
              idCardInfo, mobile, printFile, ygwxhyz);
        } 
        iModel.getSession().setAttribute("printFilePath_fk", 
            pdfFileName);
      } 
    } catch (Exception e) {
      log.error("getVoucherFile()  获取凭证打印数据出错");
      e.printStackTrace();
    } 
    return ret;
  }
  
  public static String getYZCode(ActionInternalModel iModel, Local local, Log log, TermConfigHelper termInfo) {
    String dateStr = KDate.getDateTime("", "yyyyMMdd");
    String timeStr = KDate.getDateTime("", "hhmmss");
    String termno = termInfo.getDevId();
    String tellerno = termInfo.getTeller_id();
    String txbranch = termInfo.getBrchno();
    String businessTypeName = (String)iModel.getSession().getAttribute(
        "businessType");
    String account = "";
    String amt = "";
    String accountin = "";
    String chnltxcode = CodeTableHelper.getCodeName("dzyz", 
        businessTypeName);
    String chnltxname = CodeTableHelper.getCodeName("businessType", 
        businessTypeName);
    try {
      chnltxname = new String(chnltxname.getBytes("GBK"), "GBK");
    } catch (UnsupportedEncodingException e1) {
      e1.printStackTrace();
    } 
    String traceNo = (String)iModel.getSession().getAttribute("transeqno");
    log.info("业务类型===" + businessTypeName + "===交易代码===" + chnltxcode + 
        "===交易描述===" + chnltxname + "===业务流水号===" + traceNo);
    TradePackXml tf = new TradePackXml("GBK");
    String trancode = "8001";
    String busiTyp = "KNL";
    tf.addNodePack("Request", "");
    tf.addNodePack("Head", "");
    tf.addPack("txcode", trancode);
    tf.addPack("txdate", dateStr);
    tf.addPack("txtime", timeStr);
    tf.addPack("traceno", traceNo);
    tf.addPack("txbranch", "gstjczyh20210705");
    tf.addPack("tellerno", tellerno);
    tf.addPack("termno", termno);
    tf.addPack("bankflag", "e1");
    tf.addPack("chnlflag", "A");
    tf.addNodePack("Head", "/");
    tf.addNodePack("Body", "");
    tf.addPack("account", account);
    tf.addPack("amt", amt);
    tf.addPack("accountin", accountin);
    tf.addPack("chnltxcode", chnltxcode);
    tf.addPack("chnltxname", chnltxname);
    tf.addNodePack("Body", "/");
    tf.addNodePack("Request", "/");
    String elecode = "";
    try {
      byte[] sendbuf = tf.pack(busiTyp, trancode);
      log.info("输出报文############sendbuf===" + new String(sendbuf));
      String ueSend = new String(sendbuf);
      sendbuf = ueSend.getBytes();
      SocketConnectorEx c = new SocketConnectorEx();
      String ipAddr = AppParamsHelper.getAppParam("yz_host_addr");
      int yzPort = Integer.parseInt(
          AppParamsHelper.getAppParam("yz_host_port"));
      int timeout = Integer.parseInt(AppParamsHelper.getAppParam(
            "yz_host_connect_timeout", "30000"));
      log.debug("bst_host_addr:" + ipAddr + " ;bst_host_port:" + yzPort);
      c.init((ConnectParameter)new SocketParameter(ipAddr, yzPort, timeout));
      log.debug("c.init");
      byte[] recv = (byte[])c.connect(sendbuf);
      log.debug("recv");
      c.close();
      if (recv == null || recv.length <= 8)
        log.info("输出报文############sendbuf为空"); 
      byte[] Body = new byte[recv.length - 8];
      if (recv != null && recv.length > 8)
        System.arraycopy(recv, 8, Body, 0, recv.length - 8); 
      String strBody = new String(Body, "GBK");
      log.debug("strBody:" + strBody);
      Document doc = DocumentHelper.parseText(strBody);
      Element rootElm = doc.getRootElement();
      Element bodyElm = rootElm.element("Body");
      if (!bodyElm.elements("elecode").isEmpty())
        elecode = bodyElm.element("elecode").getTextTrim(); 
      log.trace("elecode=" + elecode);
    } catch (Exception e) {
      log.info("通讯处理异常:" + ErrorsHelper.getErrorStr(e));
      e.printStackTrace();
    } finally {}
    log.trace("elecode===" + elecode);
    return elecode;
  }
  
  public static boolean createVoucher(String rptFile, Map dataMap, String filePathAndName) {
    boolean ret = false;
    try {
      String realpath = KSysUtil.getWebRoot();
      if (!realpath.startsWith("/") && "/".equals(FILE_SEP))
        realpath = "/" + realpath; 
      if (realpath.startsWith("/") && !"/".equals(FILE_SEP))
        realpath = realpath.substring(1); 
      String datastr = HtmReportHelper.readFile(String.valueOf(realpath) + rptFile);
      if (rptFile.equals(""))
        return false; 
      Set set = dataMap.keySet();
      Iterator<String> it = set.iterator();
      while (it.hasNext()) {
        String key = it.next();
        String value = (String)dataMap.get(key);
        if (value == null)
          value = ""; 
        datastr = datastr.replaceAll("\\{" + key + "\\}", value);
      } 
      ret = HtmReportHelper.writeFile(filePathAndName, datastr);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return ret;
  }
  
  public static void main(String[] args) throws Exception {
    boolean httpFlag = false;
    String fontPath = "E://WorkSpace/ISST_CB_JLYGCZ/WebRoot/app/local/chinese/report/newcard/fonts/";
    String iamgepath = "D://0000000000098888_00000035_20190713225510/";
    System.out.println(fontPath);
    String pdfFileName = String.valueOf(iamgepath) + "/loansPayBack_print_voucher.pdf";
    String printFilePath_fk = "D://0000000000098888_00000035_20190713225510/loansPayBack_print_voucher.html";
    GwiXMLWorkerHelper gwh = GwiXMLWorkerHelper.getInstance(fontPath);
    gwh.parseXHtmlEx(pdfFileName, printFilePath_fk, iamgepath, httpFlag);
  }
}
